QGIS Application - Bug report #12606
URL format in request DescribeFeature, && in URL request.
2015-04-20 01:51 AM - Peder Dalin

Status: Closed

Priority: Normal

Assignee:

Category: Web Services clients/WFS

Affected QGIS version:2.8.1 Regression?: No

Operating System: Windows Easy fix?: No

Pull Request or Patch supplied: Resolution: not reproducable
Crashes QGIS or corrupls data: Copied to github as #: 20726
Description

The WFS request DescribeFeature has two && in the URL request.

The generated URL from QGIS is
?SERVICE=WFS&VERSION=1.0.0&TYPENAME=name:layer& & REQUEST=DescribeFeatureType

This is how the URL request should look like
?SERVICE=WFS&VERSION=1.0.0&TYPENAME=name:layer& REQUEST=DescribeFeature Type

History

#1 - 2015-04-26 01:54 AM - Giovanni Manghi

- Status changed from Open to Feedback

seems fine here on QGIS master, example:

?service=WFS&version=1.0.0&request=DescribeFeature Type&typeName=area%3AEEZ_HIGHSEAS

#2 - 2015-04-28 02:35 AM - Peder Dalin

Thanks for the answer.

| have done some more research in this case. The web request in the QGIS log and the actual HT TPwebrequest from QGIS does not match. If you use a

trace program like Fiddler Web Debugger you will se the difference. In the fiddler trace request there is two && in the request.

#3 - 2015-05-04 02:27 AM - Giovanni Manghi

Peder Dalin wrote:

Thanks for the answer.

| have done some more research in this case. The web request in the QGIS log and the actual HTTPwebrequest from QGIS does not match. If you

use a trace program like Fiddler Web Debugger you will se the difference. In the fiddler trace request there is two && in the request.

| used Wireshark, there the URL shows ok.
#4 - 2015-05-10 01:12 AM - Jiirgen Fischer
- Target version changed from Version 2.8.2 to Future Release - Lower Priority

#5 - 2015-05-24 08:53 AM - Giovanni Manghi
- Status changed from Feedback to Closed
- Resolution set to not reproducable

closing for lack of feedback.

#6 - 2016-02-24 02:42 AM - Andreas Wicht

| was able to reproduce this issue.

I am on 2.12.3-Lyon sending an WFS Request and capturing it via tcpflow on Ubuntu 14.04.

1. GetCapabilities - OK

GET
[...)/MapServer/WFSServer?SERVICE=WFS&REQUEST=GetCapabilities& VERSION=1.0.0
HTTP/1.1

User-Agent: Mozilla/5.0 QGIS/2.12.3-Lyon

Connection: Keep-Alive

Accept-Encoding: gzip

Accept-Language: en-US,*

Host: someserver

HTTP/1.1 200 OK

Content-Type: text/xml
Transfer-Encoding: chunked

Date: Tue, 23 Feb 2016 15:37:35 GMT

2. DescribeFeatureType - FAIL

GET

[.../MapServer/WFSServer?SERVICE=WFS&VERSION=1.0.0& TYPENAME=NS:MyLayer&&REQUEST=DescribeFeature Type
HTTP/1.1

User-Agent: Mozilla/5.0 QGIS/2.12.3-Lyon

Connection: Keep-Alive

Accept-Encoding: gzip

Accept-Language: en-US,*

Host: someserver

HTTP/1.0 400 Missing HTTP version

in request:

Server: proxy 1.189

Content-Length: 197

Missing HTTP version in request: 'GET

[...]MapServer/WFSServer?SERVICE=WFS&VERSION=1.0.0& TYPENAME=NS:MyLayerREQU...
In this case it is a huge issue as the WFS Server is behind a proxy-server which only accepts valid (according to ogc) requests. Removing the double '&&'
leads to a successful request.

I highly suggest to evaluate this issue again.
